<?php
/**
 * @version SOFORT Gateway 3.3.0 - $Date: 2013-05-17 10:33:11 +0200 (Fri, 17 May 2013) $
 * @author SOFORT AG (integration@sofort.com)
 * @link http://www.sofort.com/
 *
 * Copyright (c) 2012 SOFORT AG
 *
 * Released under the GNU General Public License (Version 2)
 * [http://www.gnu.org/licenses/gpl-2.0.html]
 *
 * $Id: testAuth.php 6151 2013-05-17 08:33:11Z rotsch $
 */
chdir('../');
require ('includes/application_top.php');
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/helperFunctions.php');

$language = HelperFunctions::getSofortLanguage($_SESSION['language']);
include_once(DIR_FS_CATALOG.'includes/languages/'.$language.'/modules/payment/sofort_general.php');

require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/library/sofortLib.php');

if(isset($_COOKIE['osCAdminID']) && !empty($_COOKIE['osCAdminID'])) {
	ob_start();
	$isIdeal = $_POST['isIdeal'];
	$keyParts = explode(':', $_POST['k']);
	
	if (strlen($keyParts[1]) == 4){
		$key = $keyParts[0].':0'.$keyParts[1].':'.$keyParts[2];
	} else {
		$key = $_POST['k'];
	}
	
	preg_match('#([0-9]{4,6}\:[0-9]{4,6}\:[a-z0-9]{32})#', $key, $matches);
	$configKey = $matches[1];
	$SofortLib_TransactionData = new SofortLib_TransactionData($configKey);
	
	if ($isIdeal == "false") {
		$SofortLib_TransactionData->setTransaction('00000')->sendRequest();
	} else {
		$SofortLib_TransactionData->sendRequest();
	}
	
	if ($SofortLib_TransactionData->isError()) {
		if ($isIdeal == "false") {
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '".SOFORT_KEYTEST_ERROR_DESC."' WHERE configuration_key = 'SOFORT_MULTIPAY_AUTH'");
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '' WHERE configuration_key = 'SOFORT_MULTIPAY_CONFIGURATION_KEY'");
		} else {
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '".SOFORT_KEYTEST_ERROR_DESC."' WHERE configuration_key = 'SOFORT_IDEAL_CLASSIC_AUTH'");
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '' WHERE configuration_key = 'SOFORT_IDEAL_CLASSIC_CONFIGURATION_KEY'");
		}
		ob_end_clean();
		echo "f".SOFORT_KEYTEST_ERROR;
	} else {
		if ($isIdeal == "false") {
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '".SOFORT_KEYTEST_SUCCESS_DESC." ".date("d.m.Y")."' WHERE configuration_key = 'SOFORT_MULTIPAY_AUTH'");
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '".HelperFunctions::escapeSql($configKey)."' WHERE configuration_key = 'SOFORT_MULTIPAY_CONFIGURATION_KEY'");
		} else {
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '".SOFORT_KEYTEST_SUCCESS_DESC." ".date("d.m.Y")."' WHERE configuration_key = 'SOFORT_IDEAL_CLASSIC_AUTH'");
			tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = '".HelperFunctions::escapeSql($configKey)."' WHERE configuration_key = 'SOFORT_IDEAL_CLASSIC_CONFIGURATION_KEY'");
		}
		ob_end_clean();
		echo "t".$key."||".SOFORT_KEYTEST_SUCCESS;
	}
}